module hexagon(size) {
    rotate([0, 0, 360/12])
    circle(d=size, $fn=6);
}

module star(bar_amount, bar_width, bar_length) {
    for(i = [0 : 360/bar_amount: 360/2-1]) {
        rotate([0, 0, i])
        square([bar_width, bar_length], center=true);
    }
}

difference() {
    // *** THE CLOUD ***
    union() {
        // middle
        hexagon(10);
        // left branch
        translate([-2.5, 0])
        hexagon(8);
        translate([-6, -1])
        hexagon(4);
        // right branch
        translate([3, 2])
        hexagon(4);
        translate([4.5, -1])
        hexagon(5);
    }
    // *** THE STAR ***
    star(6, 0.75, 4);
}